create table BN_ENTITY_RULE (
  RULE_DBID_ bigint not null,
  ENTITY_DBID_ varchar(255)
);

create table BN_EXCEPTION_RULE (
  RULE_DBID_ bigint not null,
  EXCEPTION_DBID_ varchar(255)
);

create table BN_RULE (
  DBID_ bigint not null auto_increment,
  RULE_TYPE_ varchar(255) not null,
  RULE_NAME_ varchar(255) unique,
  RULE_LABEL_ varchar(255),
  RULE_DESCRIPTION_ text,
  RULE_TYPE_VALUE_ varchar(255),
  primary key (DBID_)
);

alter table BN_ENTITY_RULE 
  add index FK90813A655D39E3A7 (RULE_DBID_), 
  add constraint FK90813A655D39E3A7 
      foreign key (RULE_DBID_) 
      references BN_RULE (DBID_);

alter table BN_EXCEPTION_RULE 
  add index FK5BC2715F5D39E3A7 (RULE_DBID_), 
  add constraint FK5BC2715F5D39E3A7 
      foreign key (RULE_DBID_) 
      references BN_RULE (DBID_);

create index IDX_RULE_NAME on BN_RULE (RULE_NAME_);

alter table BN_COMMENTS modify MESSAGE_ text;
