alter table BN_ACT_DEF add DYN_LABEL_ text;
alter table BN_ACT_DEF add DYN_DESCRIPTION_ text;
alter table BN_ACT_DEF add SUBFLOW_VERSION_ varchar(255);
alter table BN_ACT_DEF add INSTANTIATOR_ bigint;
alter table BN_ACT_DEF add JOIN_CHECKER_ bigint;
alter table BN_ACT_DEF add LOOP_ bit;
update BN_ACT_DEF set LOOP_=b'0';
alter table BN_ACT_DEF add BEFORE_EXECUTION_ bit;
update BN_ACT_DEF set BEFORE_EXECUTION_=b'0';
alter table BN_ACT_DEF add LOOP_CONDITION_ text;
alter table BN_ACT_DEF add LOOP_MAXIMUM_ text;

alter table BN_ACT_INST add DYN_LABEL text;
alter table BN_ACT_INST add DYN_DESCR text;

alter table BN_ATTACH_DEF modify FILE_PATH_ text;

alter table BN_ATTS_INST modify ATT_INST_FILEPATH_ text;

create table BN_ATTS_METADATA (
  ATT_DBID_ bigint not null,
  VALUE_ varchar(255),
  KEY_ varchar(255) not null,
  primary key (ATT_DBID_, KEY_)
);

alter table BN_COMMENTS add PROCESS_UUID_ varchar(255);

alter table BN_IEI_ add PERMANENT_ bit;
update BN_IEI_ set PERMANENT_=b'0';
alter table BN_IEI_ add CONSUMED bit;
update BN_IEI_ set CONSUMED=b'0';

alter table BN_METADATA add unique (KEY_);

alter table BN_OEI_ add CONSUMED bit;
update BN_OEI_ set CONSUMED=b'0';

alter table BN_PROC_INST add XP_READ_ bigint;
update BN_PROC_INST set XP_READ_=0;

alter table BN_PVM_EXEC add ACT_INST_NB_ integer;
update BN_PVM_EXEC set ACT_INST_NB_=0;

alter table BN_ROLE add ROLE_UUID_ varchar(255) unique;

alter table BN_TRANS_DEF add DEFAULT_ bit;
update BN_TRANS_DEF set DEFAULT_=b'0';

alter table BN_USER add USER_UUID_ varchar(255) unique;

alter table BN_WEB_CASE add LAST_UPDATE bigint;
update BN_WEB_CASE set LAST_UPDATE=0;
alter table BN_WEB_CASE add LABEL_ varchar(255);
update BN_WEB_CASE set LABEL_='';

create table BN_WEB_TOKEN (
  DBID_ bigint not null auto_increment,
  TOKEN varchar(255),
  EXPIRATION_DATE bigint,
  IDENTITY_KEY varchar(255),
  primary key (DBID_)
);

alter table BN_ACT_DEF
  add index FK99EE4DA5D6989A77 (INSTANTIATOR_), 
  add constraint FK99EE4DA5D6989A77 foreign key (INSTANTIATOR_) references BN_CON_DEF (DBID_);

alter table BN_ACT_DEF 
  add index FK99EE4DA52169A115 (JOIN_CHECKER_), 
  add constraint FK99EE4DA52169A115 foreign key (JOIN_CHECKER_) references BN_CON_DEF (DBID_);

alter table BN_ATTS_METADATA
  add index FK976540293C0CE5CF (ATT_DBID_), 
  add constraint FK976540293C0CE5CF foreign key (ATT_DBID_) references BN_ATTS_INST (DBID_);

alter table BN_METADATA drop foreign key FK_ATT_METADATA_BR;
drop index IDX_ATT_METADATA_BR on BN_METADATA;
alter table BN_METADATA drop column ATT_ID_;

create index IDX_ROLE_UUID on BN_ROLE (ROLE_UUID_);

create index IDX_USER_UUID on BN_USER (USER_UUID_);

create index IDX_CASE_UPD on BN_WEB_CASE (LAST_UPDATE);
create index IDX_LABEL on BN_WEB_CASE (LABEL_);
create index IDX_CASE_OWN on BN_WEB_CASE (OWNER);
create index IDX_CASE_LAB on BN_WEB_CASE (NAME);