drop table BN_USER_ROLE cascade constraints;

alter table BN_ACT_DEF add DESCRIPTION_TMP clob;
update BN_ACT_DEF set DESCRIPTION_TMP = DESCRIPTION_;
alter table BN_ACT_DEF drop column DESCRIPTION_;
alter table BN_ACT_DEF rename column DESCRIPTION_TMP to DESCRIPTION_;
alter table BN_ACT_DEF add DYN_EXECUTION_SUMMARY_ clob;
alter table BN_ACT_DEF add TIMER_COND_TMP clob;
update BN_ACT_DEF set TIMER_COND_TMP = TIMER_COND;
alter table BN_ACT_DEF drop column TIMER_COND;
alter table BN_ACT_DEF rename column TIMER_COND_TMP to TIMER_COND;
alter table BN_ACT_DEF add CATCH_ERROR_ number(1,0);
update BN_ACT_DEF set CATCH_ERROR_ = 0;

alter table BN_ACT_INST add DESCR_TMP clob;
update BN_ACT_INST set DESCR_TMP = DESCR;
alter table BN_ACT_INST drop column DESCR;
alter table BN_ACT_INST rename column DESCR_TMP to DESCR;
alter table BN_ACT_INST add DYN_EXECUTION_SUMMARY clob;
alter table BN_ACT_INST add LOOP_ID_ varchar2(255 char);

alter table BN_ATTS_INST drop column ATT_INST_FILEPATH_;

alter table BN_WEB_LABEL RENAME to BN_CATEGORY;
alter table BN_CATEGORY add CATEGORY_TYPE_ varchar2(255 char) default 'WEB_LABEL' not null;
alter table BN_CATEGORY add CATEGORY_UUID_ varchar2(255 char);
alter table BN_CATEGORY add unique(CATEGORY_UUID_);

alter table BN_CON_DEF add ERROR_CODE_ varchar2(255 char);

alter table BN_DATAF_DEF add ENUM_VALUES_TMP clob;
update BN_DATAF_DEF set ENUM_VALUES_TMP = ENUM_VALUES_;
alter table BN_DATAF_DEF drop column ENUM_VALUES_;
alter table BN_DATAF_DEF rename column ENUM_VALUES_TMP to ENUM_VALUES_;
alter table BN_DATAF_DEF add SCRIPT_VALUE_TMP clob;
update BN_DATAF_DEF set SCRIPT_VALUE_TMP = SCRIPT_VALUE_;
alter table BN_DATAF_DEF drop column SCRIPT_VALUE_;
alter table BN_DATAF_DEF rename column SCRIPT_VALUE_TMP to SCRIPT_VALUE_;

alter table BN_ENTITY_RULE rename column ENTITY_DBID_ to ENTITY_ID_;

create table BN_EVENTS (
  DBID_ number(19,0) not null,
  CLASS_ varchar2(255 char) not null,
  DESCRIPTION_ clob,
  NAME_ varchar2(255 char),
  LABEL_ varchar2(255 char),
  PROCESS_UUID_ varchar2(255 char),
  ACT_UUID_ varchar2(255 char),
  TRANSITION_ number(19,0),
  CONDITION_ clob,
  EXPRESSION_ varchar2(255 char),
  ERROR_CODE_ varchar2(255 char),
  SIGNAL_CODE_ varchar2(255 char),
  EVT_DBID_ number(19,0),
  EVT_NAME_ varchar2(255 char),
  primary key (DBID_)
);

create table BN_GROUP (
    DBID_ number(19,0) not null,
    GROUP_UUID_ varchar2(255 char) unique,
    GROUP_NAME_ varchar2(255 char),
    GROUP_LABEL_ varchar2(255 char),
    GROUP_DESCRIPTION_ clob,
    PARENT_GROUP_ number(19,0),
    primary key (DBID_)
);

create table BN_GROUP_RULE (
  RULE_DBID_ number(19,0) not null,
  GROUP_UUID_ varchar2(255 char)
);

create table BN_INCOMP_EVENTS (
  INCOMING_ID number(19,0) not null,
  OUTGOING_ID number(19,0)
);

create table BN_INST_ACTUSERS (
  INSTANCE_DBID_ number(19,0) not null,
  USER_ varchar2(255 char),
  INDEX_ number(10,0) not null,
  primary key (INSTANCE_DBID_, INDEX_)
);

create table BN_MEMBERSHIP (
    DBID_ number(19,0) not null,
    MEMBERSHIP_UUID_ varchar2(255 char) unique,
    MEMBERSHIP_ROLE_ number(19,0) not null,
    MEMBERSHIP_GROUP_ number(19,0) not null,
    primary key (DBID_),
    unique (MEMBERSHIP_ROLE_, MEMBERSHIP_GROUP_)
);

create table BN_MEMBERSHIP_RULE (
  RULE_DBID_ number(19,0) not null,
  MEMBERSHIP_UUID_ varchar2(255 char)
);

create table BN_PROC_CAT (
  PROC_ID number(19,0) not null,
  CAT_ varchar2(255 char)
);

alter table BN_PROC_INST add PARENT_ACT_INST_UUID_ varchar2(255 char);
alter table BN_PROC_INST add ARCHIVED number(1,0);
update BN_PROC_INST set ARCHIVED=0;

create table BN_PROFILE_METADATA (
    DBID_ number(19,0) not null,
    PROFILE_METADATA_UUID_ varchar2(255 char) unique,
    PROFILE_METADATA_NAME_ varchar2(255 char) unique,
    PROFILE_METADATA_LABEL_ varchar2(255 char),
    primary key (DBID_)
);

alter table BN_ROLE add ROLE_DESCR_TMP clob;
update BN_ROLE set ROLE_DESCR_TMP = ROLE_DESCRIPTION_;
alter table BN_ROLE drop column ROLE_DESCRIPTION_;
alter table BN_ROLE rename column ROLE_DESCR_TMP to ROLE_DESCRIPTION_;

create table BN_ROLE_RULE (
  RULE_DBID_ number(19,0) not null,
  ROLE_UUID_ varchar2(255 char)
);

alter table BN_RULE add RULE_UUID_ varchar2(255 char);
alter table BN_RULE add unique(RULE_UUID_);
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_START';
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_READ';

create table BN_RULETYPE_POLICY (
  DBID_ number(19,0) not null,
  RULE_TYPE_VALUE_ varchar2(255 char),
  POLICY_VALUE_ varchar2(255 char),
  primary key (DBID_)
);

alter table BN_TRANS_DEF add FROM_BOUNDARY_EVT_ varchar2(255 char);

alter table BN_USER add USER_TITLE_ varchar2(255 char);
alter table BN_USER add USER_JOBTITLE_ varchar2(255 char);
alter table BN_USER add USER_MANAGER_ varchar2(255 char);
alter table BN_USER add USER_DELEGEE_ varchar2(255 char);
alter table BN_USER rename column USER_EMAIL_ to USER_PRO_EMAIL_;
alter table BN_USER add USER_PRO_PHONE_ varchar2(255 char);
alter table BN_USER add USER_PRO_MOBILE_ varchar2(255 char);
alter table BN_USER add USER_PRO_FAX_ varchar2(255 char);
alter table BN_USER add USER_PRO_BUILDING_ varchar2(255 char);
alter table BN_USER add USER_PRO_ROOM_ varchar2(255 char);
alter table BN_USER add USER_PRO_ADDRESS_ varchar2(255 char);
alter table BN_USER add USER_PRO_ZIPCODE_ varchar2(255 char);
alter table BN_USER add USER_PRO_CITY_ varchar2(255 char);
alter table BN_USER add USER_PRO_STATE_ varchar2(255 char);
alter table BN_USER add USER_PRO_COUNTRY_ varchar2(255 char);
alter table BN_USER add USER_PRO_WEBSITE_ varchar2(255 char);
alter table BN_USER add USER_PERSO_EMAIL_ varchar2(255 char);
alter table BN_USER add USER_PERSO_PHONE_ varchar2(255 char);
alter table BN_USER add USER_PERSO_MOBILE_ varchar2(255 char);
alter table BN_USER add USER_PERSO_FAX_ varchar2(255 char);
alter table BN_USER add USER_PERSO_BUILDING_ varchar2(255 char);
alter table BN_USER add USER_PERSO_ROOM_ varchar2(255 char);
alter table BN_USER add USER_PERSO_ADDRESS_ varchar2(255 char);
alter table BN_USER add USER_PERSO_ZIPCODE_ varchar2(255 char);
alter table BN_USER add USER_PERSO_CITY_ varchar2(255 char);
alter table BN_USER add USER_PERSO_STATE_ varchar2(255 char);
alter table BN_USER add USER_PERSO_COUNTRY_ varchar2(255 char);
alter table BN_USER add USER_PERSO_WEBSITE_ varchar2(255 char);

create table BN_USER_MEMBERSHIP (
  USER_DBID_ number(19,0) not null,
  MEMBERSHIP_DBID_ number(19,0) not null,
  primary key (USER_DBID_, MEMBERSHIP_DBID_)
);

create table BN_USER_PROFILE_METADATA (
  USER_DBID_ number(19,0) not null,
  USER_METADATA_VALUE_ varchar2(255 char),
  PROFILE_METADATA_DBID_ number(19,0) not null,
  primary key (USER_DBID_, PROFILE_METADATA_DBID_)
);

create table BN_USER_RULE (
  RULE_DBID_ number(19,0) not null,
  USER_UUID_ varchar2(255 char)
);

drop table BN_WEB_USER;

alter table BN_EVENTS add constraint FKFC4B1C6CE4527CDB foreign key (EVT_DBID_) references BN_ACT_DEF;
alter table BN_EVENTS add constraint FKFC4B1C6C9F5E2C47 foreign key (TRANSITION_) references BN_TRANS_DEF;

create index IDX_GROUP_PARENT on BN_GROUP (PARENT_GROUP_);
create index IDX_GROUP_NAME on BN_GROUP (GROUP_NAME_);
create index IDX_GROUP_UUID on BN_GROUP (GROUP_UUID_);
alter table BN_GROUP add constraint FK8C5F00AC3308C74D foreign key (PARENT_GROUP_) references BN_GROUP;

alter table BN_GROUP_RULE add constraint FK81E3D2AF5D39E3A7 foreign key (RULE_DBID_) references BN_RULE;

create index IDX_INCOMING_INCOMP_ on BN_INCOMP_EVENTS (INCOMING_ID);
alter table BN_INCOMP_EVENTS add constraint FK_INCOMING_INCOMP foreign key (INCOMING_ID) references BN_IEI_;

create index IDX_INST_ACTUSERS on BN_INST_ACTUSERS (INSTANCE_DBID_);
alter table BN_INST_ACTUSERS add constraint FK_INST_ACTUSERS foreign key (INSTANCE_DBID_) references BN_PROC_INST;

create index IDX_MEMBERSHIP_UUID on BN_MEMBERSHIP (MEMBERSHIP_UUID_);
alter table BN_MEMBERSHIP add constraint FKE3CDD9A9734D1EA1 foreign key (MEMBERSHIP_GROUP_) references BN_GROUP;
alter table BN_MEMBERSHIP add constraint FKE3CDD9A928CF6E7D foreign key (MEMBERSHIP_ROLE_) references BN_ROLE;

alter table BN_MEMBERSHIP_RULE add constraint FKE5B60FD25D39E3A7 foreign key (RULE_DBID_) references BN_RULE;

create index IDX_PROC_CAT on BN_PROC_CAT (PROC_ID);
alter table BN_PROC_CAT add constraint FK_PROC_CAT foreign key (PROC_ID) references BN_PROC_DEF;

create index IDX_PROFILE_METADATA_UUID on BN_PROFILE_METADATA (PROFILE_METADATA_UUID_);
create index IDX_PROFILE_METADATA_NAME on BN_PROFILE_METADATA (PROFILE_METADATA_NAME_);

alter table BN_ROLE_RULE add constraint FKBC9DBCF25D39E3A7 foreign key (RULE_DBID_) references BN_RULE;
create index IDX_RULE_UUID on BN_RULE (RULE_UUID_);

alter table BN_USER_MEMBERSHIP add constraint FKD55F6ED7A76CD75A foreign key (MEMBERSHIP_DBID_) references BN_MEMBERSHIP;
alter table BN_USER_MEMBERSHIP add constraint FKD55F6ED7EA9FC244 foreign key (USER_DBID_) references BN_USER;

alter table BN_USER_PROFILE_METADATA add constraint FKA3C9A766FE1E43BD foreign key (PROFILE_METADATA_DBID_) references BN_PROFILE_METADATA;
alter table BN_USER_PROFILE_METADATA add constraint FKA3C9A766EA9FC244 foreign key (USER_DBID_) references BN_USER;

alter table BN_USER_RULE add constraint FKBCD31EBD5D39E3A7 foreign key (RULE_DBID_) references BN_RULE;
