alter table BN_USER_ROLE drop constraint FKBCD30837E42731DA
go
alter table BN_USER_ROLE drop constraint FKBCD30837EA9FC244
go

alter table BN_ACT_DEF alter column DESCRIPTION_ text
go
alter table BN_ACT_DEF add DYN_EXECUTION_SUMMARY_ text null
go
alter table BN_ACT_DEF alter column TIMER_COND text
go
alter table BN_ACT_DEF add CATCH_ERROR_ tinyint null
go
update BN_ACT_DEF set CATCH_ERROR_ = 0
go

alter table BN_ACT_INST alter column DESCR text
go
alter table BN_ACT_INST add DYN_EXECUTION_SUMMARY text null
go
alter table BN_ACT_INST add LOOP_ID_ varchar(255) null
go

alter table BN_ATTS_INST drop column ATT_INST_FILEPATH_
go

EXEC sp_RENAME 'BN_WEB_LABEL', 'BN_CATEGORY'
go
alter table BN_CATEGORY add CATEGORY_TYPE_ varchar(255) default 'WEB_LABEL' not null
go
alter table BN_CATEGORY add CATEGORY_UUID_ varchar(255) null
go

alter table BN_CON_DEF add ERROR_CODE_ varchar(255) null
go

alter table BN_DATAF_DEF alter column ENUM_VALUES_ text
go
alter table BN_DATAF_DEF alter column SCRIPT_VALUE_ text
go

EXEC sp_RENAME 'BN_ENTITY_RULE.ENTITY_DBID_', 'ENTITY_ID_' , 'COLUMN'
go

create table BN_EVENTS (
  DBID_ numeric(19,0) identity not null,
  CLASS_ varchar(255) not null,
  DESCRIPTION_ text null,
  NAME_ varchar(255) null,
  LABEL_ varchar(255) null,
  PROCESS_UUID_ varchar(255) null,
  ACT_UUID_ varchar(255) null,
  TRANSITION_ numeric(19,0) null,
  CONDITION_ text null,
  EXPRESSION_ varchar(255) null,
  ERROR_CODE_ varchar(255) null,
  SIGNAL_CODE_ varchar(255) null,
  EVT_DBID_ numeric(19,0) null,
  EVT_NAME_ varchar(255) null,
  primary key (DBID_)
)
go

create table BN_GROUP (
  DBID_ numeric(19,0) identity not null,
  GROUP_UUID_ varchar(255) null unique,
  GROUP_NAME_ varchar(255) null,
  GROUP_LABEL_ varchar(255) null,
  GROUP_DESCRIPTION_ text null,
  PARENT_GROUP_ numeric(19,0) null,
  primary key (DBID_)
)
go

create table BN_GROUP_RULE (
  RULE_DBID_ numeric(19,0) not null,
  GROUP_UUID_ varchar(255) null
)
go

create table BN_INCOMP_EVENTS (
  INCOMING_ID numeric(19,0) not null,
  OUTGOING_ID numeric(19,0) null
)
go

create table BN_INST_ACTUSERS (
  INSTANCE_DBID_ numeric(19,0) not null,
  USER_ varchar(255) null,
  INDEX_ int not null,
  primary key (INSTANCE_DBID_, INDEX_)
)
go

create table BN_MEMBERSHIP (
  DBID_ numeric(19,0) identity not null,
  MEMBERSHIP_UUID_ varchar(255) null unique,
  MEMBERSHIP_ROLE_ numeric(19,0) not null,
  MEMBERSHIP_GROUP_ numeric(19,0) not null,
  primary key (DBID_),
  unique (MEMBERSHIP_ROLE_, MEMBERSHIP_GROUP_)
)
go

create table BN_MEMBERSHIP_RULE (
  RULE_DBID_ numeric(19,0) not null,
  MEMBERSHIP_UUID_ varchar(255) null
)
go

create table BN_PROC_CAT (
  PROC_ID numeric(19,0) not null,
  CAT_ varchar(255) null
)
go

alter table BN_PROC_INST add PARENT_ACT_INST_UUID_ varchar(255) null
go
alter table BN_PROC_INST add ARCHIVED tinyint null
go
update BN_PROC_INST set ARCHIVED=0
go

create table BN_PROFILE_METADATA (
    DBID_ numeric(19,0) identity not null,
    PROFILE_METADATA_UUID_ varchar(255) null unique,
    PROFILE_METADATA_NAME_ varchar(255) null unique,
    PROFILE_METADATA_LABEL_ varchar(255) null,
    primary key (DBID_)
)
go

alter table BN_ROLE alter column ROLE_DESCRIPTION_ text
go

create table BN_ROLE_RULE (
  RULE_DBID_ numeric(19,0) not null,
  ROLE_UUID_ varchar(255) null
)
go

alter table BN_RULE add RULE_UUID_ varchar(255) null
go
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_START'
go
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_READ'
go

create table BN_RULETYPE_POLICY (
  DBID_ numeric(19,0) identity not null,
  RULE_TYPE_VALUE_ varchar(255) null,
  POLICY_VALUE_ varchar(255) null,
  primary key (DBID_)
)
go

alter table BN_TRANS_DEF add FROM_BOUNDARY_EVT_ varchar(255) null
go

alter table BN_USER add USER_TITLE_ varchar(255) null
go
alter table BN_USER add USER_JOBTITLE_ varchar(255) null
go
alter table BN_USER add USER_MANAGER_ varchar(255) null
go
alter table BN_USER add USER_DELEGEE_ varchar(255) null
go
EXEC sp_RENAME 'BN_USER.USER_EMAIL_', 'USER_PRO_EMAIL_' , 'COLUMN'
go
alter table BN_USER add USER_PRO_PHONE_ varchar(255) null
go
alter table BN_USER add USER_PRO_MOBILE_ varchar(255) null
go
alter table BN_USER add USER_PRO_FAX_ varchar(255) null
go
alter table BN_USER add USER_PRO_BUILDING_ varchar(255) null
go
alter table BN_USER add USER_PRO_ROOM_ varchar(255) null
go
alter table BN_USER add USER_PRO_ADDRESS_ varchar(255) null
go
alter table BN_USER add USER_PRO_ZIPCODE_ varchar(255) null
go
alter table BN_USER add USER_PRO_CITY_ varchar(255) null
go
alter table BN_USER add USER_PRO_STATE_ varchar(255) null
go
alter table BN_USER add USER_PRO_COUNTRY_ varchar(255) null
go
alter table BN_USER add USER_PRO_WEBSITE_ varchar(255) null
go
alter table BN_USER add USER_PERSO_EMAIL_ varchar(255) null
go
alter table BN_USER add USER_PERSO_PHONE_ varchar(255) null
go
alter table BN_USER add USER_PERSO_MOBILE_ varchar(255) null
go
alter table BN_USER add USER_PERSO_FAX_ varchar(255) null
go
alter table BN_USER add USER_PERSO_BUILDING_ varchar(255) null
go
alter table BN_USER add USER_PERSO_ROOM_ varchar(255) null
go
alter table BN_USER add USER_PERSO_ADDRESS_ varchar(255) null
go
alter table BN_USER add USER_PERSO_ZIPCODE_ varchar(255) null
go
alter table BN_USER add USER_PERSO_CITY_ varchar(255) null
go
alter table BN_USER add USER_PERSO_STATE_ varchar(255) null
go
alter table BN_USER add USER_PERSO_COUNTRY_ varchar(255) null
go
alter table BN_USER add USER_PERSO_WEBSITE_ varchar(255) null
go

create table BN_USER_MEMBERSHIP (
  USER_DBID_ numeric(19,0) not null,
  MEMBERSHIP_DBID_ numeric(19,0) not null,
  primary key (USER_DBID_, MEMBERSHIP_DBID_)
)
go

create table BN_USER_PROFILE_METADATA (
  USER_DBID_ numeric(19,0) not null,
  USER_METADATA_VALUE_ varchar(255) null,
  PROFILE_METADATA_DBID_ numeric(19,0) not null,
  primary key (PROFILE_METADATA_DBID_, USER_DBID_)
)
go

drop table BN_USER_ROLE
go

create table BN_USER_RULE (
  RULE_DBID_ numeric(19,0) not null,
  USER_UUID_ varchar(255) null
)
go

drop table BN_WEB_USER
go

alter table BN_EVENTS add constraint FKFC4B1C6CE4527CDB foreign key (EVT_DBID_) references BN_ACT_DEF
go
alter table BN_EVENTS add constraint FKFC4B1C6C9F5E2C47 foreign key (TRANSITION_) references BN_TRANS_DEF
go

create index IDX_GROUP_PARENT on BN_GROUP (PARENT_GROUP_)
go
create index IDX_GROUP_NAME on BN_GROUP (GROUP_NAME_)
go
create index IDX_GROUP_UUID on BN_GROUP (GROUP_UUID_)
go
alter table BN_GROUP add constraint FK8C5F00AC3308C74D foreign key (PARENT_GROUP_) references BN_GROUP
go

alter table BN_GROUP_RULE add constraint FK81E3D2AF5D39E3A7 foreign key (RULE_DBID_) references BN_RULE
go

create index IDX_INCOMING_INCOMP_ on BN_INCOMP_EVENTS (INCOMING_ID)
go
alter table BN_INCOMP_EVENTS add constraint FK_INCOMING_INCOMP foreign key (INCOMING_ID) references BN_IEI_
go

create index IDX_INST_ACTUSERS on BN_INST_ACTUSERS (INSTANCE_DBID_)
go
alter table BN_INST_ACTUSERS add constraint FK_INST_ACTUSERS foreign key (INSTANCE_DBID_) references BN_PROC_INST
go

create index IDX_MEMBERSHIP_UUID on BN_MEMBERSHIP (MEMBERSHIP_UUID_)
go
alter table BN_MEMBERSHIP add constraint FKE3CDD9A9734D1EA1 foreign key (MEMBERSHIP_GROUP_) references BN_GROUP
go
alter table BN_MEMBERSHIP add constraint FKE3CDD9A928CF6E7D foreign key (MEMBERSHIP_ROLE_) references BN_ROLE
go

alter table BN_MEMBERSHIP_RULE add constraint FKE5B60FD25D39E3A7 foreign key (RULE_DBID_) references BN_RULE
go

create index IDX_PROC_CAT on BN_PROC_CAT (PROC_ID)
go
alter table BN_PROC_CAT add constraint FK_PROC_CAT foreign key (PROC_ID) references BN_PROC_DEF
go

create index IDX_PROFILE_METADATA_UUID on BN_PROFILE_METADATA (PROFILE_METADATA_UUID_)
go
create index IDX_PROFILE_METADATA_NAME on BN_PROFILE_METADATA (PROFILE_METADATA_NAME_)
go

alter table BN_ROLE_RULE add constraint FKBC9DBCF25D39E3A7 foreign key (RULE_DBID_) references BN_RULE
go

create index IDX_RULE_UUID on BN_RULE (RULE_UUID_)
go

alter table BN_USER_MEMBERSHIP add constraint FKD55F6ED7A76CD75A foreign key (MEMBERSHIP_DBID_) references BN_MEMBERSHIP
go
alter table BN_USER_MEMBERSHIP add constraint FKD55F6ED7EA9FC244 foreign key (USER_DBID_) references BN_USER
go

alter table BN_USER_PROFILE_METADATA add constraint FKA3C9A766FE1E43BD foreign key (PROFILE_METADATA_DBID_) references BN_PROFILE_METADATA
go
alter table BN_USER_PROFILE_METADATA add constraint FKA3C9A766EA9FC244 foreign key (USER_DBID_) references BN_USER
go

alter table BN_USER_RULE add constraint FKBCD31EBD5D39E3A7 foreign key (RULE_DBID_) references BN_RULE
go
